"use strict";
exports.__esModule = true;
var i18next_1 = require("i18next");
var i18next_node_fs_backend_1 = require("i18next-node-fs-backend");
var i18next_express_middleware_1 = require("i18next-express-middleware");
var body_parser_1 = require("body-parser");
exports.applyI18n = function (app) {
    i18next_1["default"]
        .use(i18next_node_fs_backend_1["default"])
        .init({
        lng: 'en',
        fallbackLng: 'en',
        preload: ['fi', 'en'],
        //defaultNS: 'main',
        ns: ['main'],
        saveMissing: true,
        //debug: true,
        backend: {
            loadPath: 'resources/locales/{{lng}}/{{ns}}.json',
            addPath: 'resources/locales/{{lng}}/{{ns}}.missing.json'
        }
    });
    app.use(body_parser_1["default"].json()); // for parsing application/json
    app.use(body_parser_1["default"].urlencoded({ extended: true })); // for parsing application/x-www-form-urlencoded
    app.use(i18next_express_middleware_1["default"].handle(i18next_1["default"], {
    // ignoreRoutes: ["/foo"],
    // removeLngFromUrl: false
    }));
    //app.use('/locales', express.static('locales'));
    app.post('/locales/add/:lng/:ns', i18next_express_middleware_1["default"].missingKeyHandler(i18next_1["default"]));
    //app.post('/locales/add/:lng/:ns', (req, res) => {
    //  console.warn(req.query, req.body)
    //})
};
