"use strict";
exports.__esModule = true;
var http_proxy_1 = require("http-proxy");
// Set proxy
exports.applyProxy = function (app, listener, argv) {
    var proxy = new http_proxy_1["default"].createProxyServer({
        target: (argv.apiSecure ? 'https://' : 'http://') + argv.apiHost
    });
    proxy.on('error', function (err, req, res) {
        try {
            res.end(err);
        }
        catch (e) {
            //
        }
    });
    console.log('');
    // Proxying of viewed files must be defined before the generic static file handling
    app.get('/view/*', function (req, res) {
        proxy.web(req, res);
    });
    listener.on('upgrade', function (req, socket, head) {
        console.log('Upgrade to websocket', req.headers['x-forwarded-for'] || req.connection.remoteAddress);
        proxy.ws(req, socket, head);
    });
    console.log('API address: ' + proxy.options.target);
};
