import express from 'express';
import httpProxy from 'http-proxy';



// Set proxy
export const applyProxy = (app: ReturnType<typeof express>, listener: any, argv: any) => {
  const proxy = new httpProxy.createProxyServer({
    target: (argv.apiSecure ? 'https://' : 'http://') + argv.apiHost
  });

  proxy.on('error', function (err, req, res) {
    try {
      res.end(err);
    } catch (e) { 
      //
    }
  });

  console.log('');

  // Proxying of viewed files must be defined before the generic static file handling
  app.get('/view/*', (req, res) => {
    proxy.web(req, res);
  });

  listener.on('upgrade', function (req, socket, head) {
    console.log('Upgrade to websocket', req.headers['x-forwarded-for'] || req.connection.remoteAddress);
    proxy.ws(req, socket, head);
  });

  
  console.log('API address: ' + proxy.options.target);
};
