"use strict";
exports.__esModule = true;
var path_1 = require("path");
var chalk_1 = require("chalk");
var webpack_1 = require("webpack");
var webpack_config_js_1 = require("../webpack.config.js");
// Set up Webpack
exports.applyWebpack = function (app) {
    console.log(chalk_1["default"].bold('Building webpack...'));
    var compiler = webpack_1["default"](Object.assign(webpack_config_js_1["default"], {
        mode: 'development'
    }));
    app.use(require('webpack-dev-middleware')(compiler, {
        historyApiFallback: true,
        logLevel: 'warn',
        publicPath: webpack_config_js_1["default"].output.publicPath,
        watchOptions: {
            ignored: /resources\/locales/
        }
    }));
    app.use(require('webpack-hot-middleware')(compiler));
    // Setup static file handling
    // https://github.com/ampedandwired/html-webpack-plugin/issues/145#issuecomment-170554832
    app.use('*', function (req, res, next) {
        var filename = path_1["default"].join(compiler.outputPath, 'index.html');
        compiler.outputFileSystem.readFile(filename, function (err, result) {
            if (err) {
                return next(err);
            }
            res.set('content-type', 'text/html');
            res.send(result);
            res.end();
            return undefined;
        });
    });
};
